Date: Sat, 19 Feb 2011 21:57:00 -0500
Mime-Version: 1.0 (Produced by PhpWiki 1.6.6)
Content-Type: application/x-phpwiki;
  pagename=KnowledgeBase%2FFreeBSD%2Fmerge-unchanged.sh;
  author=CyberLeo;
  owner=CyberLeo;
  version=5;
  lastmodified=1298170620;
  created=1298170620;
  author_id=CyberLeo;
  hits=1739;
  charset=UTF-8
Content-Transfer-Encoding: binary

Alternately, just pass mergemaster the flags -U (auto-upgrade files that have not been user-modified) and -i (auto-install new files)
----
Run mergemaster to set up /var/tmp/temproot, then abort it before touching any files.

Run this against it, to install all files whose only change is their CVS ID

Rerun mergemaster, and it will ignore the newly updated files

<code brush="bash">
cd /var/tmp/temproot
find . -type f | while read file
do
  if [ -e "${file}" -a -e "${DESTDIR}/${file}" ]
  then
    # Detect if there are any additions or deletions
    diff=$(diff -e "${file}" "${DESTDIR}/${file}")
    [ $? -eq 0 ] && continue

    # Ignore files with additions or deletions
    echo "${diff}" | egrep -q '^[0-9]+[ad]$' && continue

    # Ignore files with more than one change
    changes="$(echo "${diff}" | egrep -c '^[0-9]+c$')"
    [ "${changes}" -ne 1 ] && continue

    # Make sure the changed line is the FreeBSD CVS tag
    cvstag="$(echo "${diff}" | grep -c '$FreeBSD: ')"
    [ "${cvstag}" -ne 1 ] && continue
  fi

  mv -vf "${file}" "${DESTDIR}/${file}"
done
</code>
