Date: Mon, 19 Oct 2009 02:17:21 -0400
Mime-Version: 1.0 (Produced by PhpWiki 1.6.6)
Content-Type: application/x-phpwiki;
  pagename=KnowledgeBase%2FScripts%2Fbcat.sh;
  author=CyberLeo;
  owner=CyberLeo;
  version=1;
  lastmodified=1255933041;
  created=1255933041;
  author_id=CyberLeo;
  hits=914;
  charset=UTF-8
Content-Transfer-Encoding: binary

<code brush="bash">
#!/bin/sh

# This script abstracts my most common use of 'bar'. I.e. spilling the
#  contents of a file or blockdev to stdout while progressbar'ing.
# Requires clpbar (app-misc/clpbar) (http://clpbar.sourceforge.net)

pebkac() {
  [ "${*}" ] && printf "%s\n\n" "${*}" >&2
  echo "Usage: $(basename "${0}") <filename>" >&2
  echo "" >&2
  echo "Prints a pretty ASCII progress bar to stderr while" >&2
  echo " catting the contents of the specified file to stdout." >&2
  exit 1
}

file="${1}"
[ -z "${file}" -o -d "${file}" ] && pebkac
type="$(stat -c "%F" "${file}")"

case "${type}" in
regular\ file) size="$(stat -c "%s" "${file}")" ;;
block\ special\ file) size="$(( $(/sbin/blockdev --getsz "${file}") * 512 ))" ;;
*) pebkac "Unrecognized type '${type}'" ;;
esac

exec bar -dan -s "${size}" -if "${file}"
</code>
