Date: Sat, 10 Apr 2010 20:06:50 -0400
Mime-Version: 1.0 (Produced by PhpWiki 1.6.6)
Content-Type: application/x-phpwiki;
  pagename=KnowledgeBase%2FScripts%2Fepochdays.sh;
  author=CyberLeo;
  owner=CyberLeo;
  version=2;
  lastmodified=1270944410;
  created=1270944410;
  author_id=CyberLeo;
  hits=1085;
  charset=UTF-8
Content-Transfer-Encoding: binary

<code brush="bash">
case "$(uname -s)" in
Linux)
  date_to_epochdays() {
    [ "${1}" ] || return 1
    echo $(( $(date +%s -d "${1}") / 86400 ))
  }
  epochdays_to_date() {
    [ "${1}" ] || return 1
    date -d "1970-01-01 $(( ${1} * 86400 )) sec" +%Y-%m-%d
  }
  ;;
FreeBSD)
  date_to_epochdays() {
    [ "${1}" ] || return 1
    echo $(( $(date -j -f %Y-%m-%d "%{1}" +%s) / 86400 ))
  }
  epochdays_to_date() {
    [ "${1}" ] || return 1
    date -jr $(( ${1} * 86400 )) +%Y-%m-%d
  }
  ;;
esac
</code>
