Date: Wed, 16 Sep 2009 06:27:31 -0400
Mime-Version: 1.0 (Produced by PhpWiki 1.6.6)
Content-Type: application/x-phpwiki;
  pagename=KnowledgeBase%2FScripts%2Fhexdump.rb;
  author=CyberLeo;
  owner=CyberLeo;
  version=1;
  lastmodified=1253096851;
  created=1253096851;
  author_id=CyberLeo;
  hits=1056;
  charset=UTF-8
Content-Transfer-Encoding: binary

<code brush="ruby">
UNMENTIONABLES = Range.new(0, 255).select {|ord|
  ord < 32 || ord > 126
}.map {|ord| ord.chr }.join

def hexdump(block)
  # Format: <address> <8 bytes> <8 bytes> |<16 chars>|
  result = ""

  count = (block.length / 16).to_i
  slack = (block.length % 16).to_i

  Range.new(0, count - 1).each {|index|
    offset = index * 16
    sample = block[offset, 16]

    fmt = "%08x  " + ("%02x " * 8) + " " +
      ("%02x " * 8) + " |%s|\n"
    args = []
    args << (offset % 0x100000000)
    sample.each_byte {|byte| args << byte }
    args << sample.tr(UNMENTIONABLES, '.')
    result += sprintf(fmt, *args)
  }

  # Handle slack
  if slack > 0
    offset = count * 16
    sample = block[offset, slack]

    fmt = "%08x  "
    if slack >= 8
      fmt += ("%02x " * 8) + " "
    end
    fmt += ("%02x " * (slack % 8)) + " "

    args = []
    args << (offset % 0x100000000)
    sample.each_byte {|byte| args << byte }

    tmp = sprintf(fmt, *args)
    tmp += " " * (60 - tmp.length) if tmp.length < 60
    tmp += sprintf("|%s|\n", sample.tr(UNMENTIONABLES, '.'))
    result += tmp
  end
  result
end
</code>
